#include	<mriext.h>
#include	<string.h>
#include	"tmp_def.h"
#include	"duscc.h"

extern void	rs_snd();
extern int	inportb(),outportb(),yes();

extern char	crflg,stpflg,nextflg;
extern char	err_msg[],buffer[];
extern int	ps_ctr;
extern int	ps_data;

void	ps_init();
int	ps_sense();


void	ps()
{
	char	psbuf[20];
	int	col;


	rs_snd("\n **** Photo Sensor Circuit Test **** \n");

	rs_snd("\n  IO Sub board (photo sensor circuit) is ready ? \n");
	if ( yes() != 0 ) return;

	ps_init();

	/*	[1] Photo Sensor Sense Test	*/
	strcpy(err_msg,"\n ---- Check PS:Photo Sense Function ---- \n");
	rs_snd("\n [1] Photo Sensor Sense Test \n");
	if ( ps_sense() != 0 ) return;

	/*	[2] Photo Sensor Interrupt Test	*/
	strcpy(err_msg,"\n ---- Check PS:PS Interrupt Function ---- \n");
	rs_snd("\n [2] Photo Sensor Interrupt Test \n");
	ps_ctr = 0;
	rs_snd("\n  Take lights to photo sensor for interrupt.(If there is no response, hit F1 key for break.)\n");
	outportb(PSR2,0x0f);	/*	HnS Clear		*/
	outportb(PBCR2,0xAA);	/*	interrupt enable	 95.1.17 0x32->0xAA*/
	outportb(VIMR,0x02);	/*	VME IRQ1  enable	*/


	while ( ps_ctr == 0 && stpflg != ACTIVE );

	outportb(VIMR,0x00);	/*	VME IRQ   disable	*/
	outportb(PBCR2,0xA0);	/*	interrupt disable	95.1.17 0x30->0xA0*/

	if ( stpflg == ACTIVE )
	{
		rs_snd(err_msg);
		return;
	}
	outportb(TCR1,0x00);	/*	PI/T(X)TOUT stop	*/

	/*	display sensor data  in 8 coloum	*/
	strcpy(buffer,"00000000");
	col = itostr( (unsigned int)ps_data, psbuf, 2);
	itostr( (unsigned int)ps_data, buffer+(8-col), 2 );
	rs_snd("\ndata =");
	rs_snd(buffer);
	rs_snd("\n");

	rs_snd("  O.K. \n");

	rs_snd("\n ****  Photo Sensor Circuit Test is Complete **** \n");
}


void	ps_init()
{
	/*	PI/T 1	*/
	outportb(TCR1,0x00);	/*	clear TCR1	*/
	outportl(CPR1,0x000001);/*	TOUT 125kHz	*/
			/*	0x01 = (1/125kHz)/2 /(1/8MHz)/32 prescaler	*/
	outportb(TCR1,0x41);	/*	square wave	*/


	/*	PI/T 2	*/
	outportb(PGCR2,0x00);	/*	clear PGCR2	*/
	outportb(PSRR2,0x1c);
	outportb(PBCR2,0xA0);	/*	submode 00	1995.1.17 0x00->0xA0 submode 1x*/
	outportb(PBDDR2,0x00);	/*	all input	*/
	outportb(PGCR2,0x28);	/*	mode 0	,H3 enable	*/

	/*	set vector for interrupt	*/
	asm(
"	MOVEA.L		#$128,A0	*	128(h) = (72+2)(d) * 4",
"	MOVE.L		#_psint,(A0)"
	);
	outportb(PIVR2,72+2 );	/*	infrared ray sensor interrupt causes by H3	*/
}


int	ps_sense()
{
	int	i;

	while ( nextflg != ACTIVE && stpflg != ACTIVE )
	{
		rs_snd("\n  Hit return key to watch photo sensor data. ( Hit F2 key for next. ) : ");
		while ( crflg != ACTIVE && nextflg != ACTIVE && stpflg != ACTIVE );
		crflg = !ACTIVE;
		ps_data = inportb(PBDR2);
		rs_snd("\n  Photo Sensor Data : ");
		for ( i= 7 ; i >= 0 ; i-- )
		{
			rs_snd("\n  [");
			itoa(i,buffer);
			rs_snd(buffer);
			rs_snd("] : ");
			if ( (ps_data & (0x01 << i)) != 0 ) rs_snd("ON ");
			else rs_snd("OFF ");
		}
	}
	nextflg = !ACTIVE;
	if ( stpflg == ACTIVE )
	{
			rs_snd(err_msg);
			return(1);
	}
	rs_snd("  O.K. \n");
	return(0);
}


/*	infrared ray sensor interrupt	*/
interrupt void	psint()
{
	outportb(PSR2,0x04);			/*	clear H3S	*/
	ps_data = (inportb(PBDR2) & 0xff);	/*	sensor data	*/
	ps_ctr++;				/*	interrupt counter */
}

