#include	<mriext.h>
#include	<string.h>
#include	"tmp_def.h"
#include	"duscc.h"

extern void	rs_snd();
extern int	outportb(),yes(),ret(),inp();

extern char	getbuf[],*end_get,stpflg,crflg,nextflg;
extern char	err_msg[],buffer[];

void	pwm_init();
int	duty_set(),switching();


void	pwm()
{
	rs_snd("\n **** PWM Circuit Test **** \n");

	rs_snd("\n  IO Sub board (PWM circuit) is ready ? \n");
	if ( yes() != 0 ) return;

	pwm_init();

	/*	[1] Speed Change Test	*/
	strcpy(err_msg,"\n ---- Check PWM:Speed Change Function ---- \n");
	rs_snd("\n [1] Counter Test \n");
	outportb(PADR1,STPWHL);			/*	stop	wheels	*/
	outportb(PBDR1,STPWHL);
	rs_snd("\n  Set a tachometer to right wheel. \n");
	if ( ret() != 0 ) return;
	if ( duty_set(PADR1) != 0 ) return;
	rs_snd("\n  Set a tachometer to left wheel. \n");
	if ( ret() != 0 ) return;
	if ( duty_set(PBDR1) != 0 ) return;
	rs_snd("  O.K. \n");

	/*	[2] CW/CCW Switching Test	*/
 	strcpy(err_msg,"\n ---- Check PWM:CW/CCW Switching Function ---- \n");
	rs_snd("\n [2] CW/CCW Switching Test \n");
	rs_snd("\n  Right wheel test: \n");
	if ( ret() != 0 ) return;
	if ( switching(PADR1) != 0 ) return;
	rs_snd("\n  Left while test: \n");
	if ( ret() != 0 ) return;
	if ( switching(PBDR1) != 0 ) return;

	rs_snd("\n **** PWM Circuit Test is Complete **** \n");
}


void	pwm_init()
{
	/*	PI/T 1	*/
	outportb(PGCR1,0x00);	/*	clear PGCR1	*/
	outportb(PSRR1,0x00);
	outportb(PACR1,0x80);	/*	submode 1x	*/
	outportb(PADDR1,0xff);	/*	all output	*/
	outportb(PBCR1,0x80);	/*	submode 1x	*/
	outportb(PBDDR1,0xff);	/*	all output	*/
	outportb(PGCR1,0x00);	/*	mode 0		*/
	outportb(TCR1,0x00);	/*	clear TCR1	*/
	outportl(CPR1,0x000001);/*	TOUT 125kHz	*/
			/* 0x01 = (1/125kHz)/2 /(1/8MHz)/32 prescaler	*/
	outportb(TCR1,0x41);	/*	square wave	*/
}


int	duty_set( port )
char	*port;
{
	int	duty;

	outportb(port,STPWHL);	/*	stop wheel	*/
	while ( nextflg != ACTIVE && stpflg != ACTIVE )
	{
		duty = NON;
		while ( duty == NON && nextflg != ACTIVE && stpflg != ACTIVE )
		{
			rs_snd("\n  Input Duty Rate [0-100] ( Hit F2 key for next )  >> ");
			duty = inp();
			if ( duty <0 || duty > 100 ) duty = NON;
		}
		outportb(port,(duty * D_MAX /100)<<1);
		itoa(duty,buffer);
		rs_snd("  Duty rate : ");
		rs_snd(buffer);
	}
	nextflg = !ACTIVE;
	if ( stpflg == ACTIVE )
	{
		rs_snd(err_msg);
		return(1);
	}
	rs_snd("  O.K. \n");
	outportb(port,STPWHL);	/*	stop wheel	*/
	return(0);
}


int	switching( port )
char	*port;
{
	char	dir;
 
	dir = CW;
	outportb(port,(LOWSPD<<1) + dir);
	while( nextflg != ACTIVE && stpflg != ACTIVE )
	{
		rs_snd("  Hit return key for switching.( Hit F2 key for next.) ");
		while ( crflg != ACTIVE && nextflg != ACTIVE && stpflg != ACTIVE );
		crflg = !ACTIVE;

		if ( nextflg != ACTIVE && stpflg != ACTIVE )
		{
			dir = 1-dir;
			outportb(port,(LOWSPD<<1) + dir);
		}
	}
	nextflg = !ACTIVE;
	if ( stpflg == ACTIVE )
	{
		rs_snd(err_msg);
		return(1);
	}
	rs_snd("  O.K. \n");
	outportb(port,STPWHL);	/*	stop wheel	*/
	return(0);
}

