#include	"tmp_def.h"
#include	"duscc.h"

extern int	inportb(),outportb(),inportl(),outportl(),inp();
extern void	pwm_init();	/*	stop wheel at initialize	*/

void	rs_init(),rs_snd(),rs_rcv();	/*	RS-232C Drivers		*/
void	init();				/*	initialize module	*/
void	rtc_clr();
void	end();				/*	end module		*/


int	sw_ctr = 0;		/*	switch interrupt counter			*/
int	ts_ctr = 0;		/*	touch sensor interrupt counter			*/
int	sss_ctr = 0;		/*	ss sensor interrupt counter			*/
int	ps_ctr = 0;		/*	photo sensor interrupt counter			*/

char	getbuf[BUFSIZE];	/*	buffer for receive				*/
char	*end_get = getbuf;	/*	pointer which points end of received data	*/
char	stpflg = !ACTIVE;	/*	stop flag for communication			*/
char	crflg = !ACTIVE;	/*	CR flag for communication			*/
char	nextflg = !ACTIVE;	/*	next flag for TMP				*/

char	endflg = !ACTIVE;	/*	end flag	*/

char	buffer[BUFSIZE];	/*	buffer for general purpose	*/
char	err_msg[BUFSIZE];	/*	buffer for error message	*/

char	led_data[LED_NO];	/*	buffer for 7seg.LED data	*/
int	ps_data;		/*	photo sensor data		*/


main()
{
	asm(
"	MOVE	#$2000,SR	* Enable interrupt	"
	);


	init();			/*	initialize DUSCC & RTC	*/

	while ( endflg != ACTIVE )
	{
		stpflg = !ACTIVE;

		switch ( menu() )
		{
			case 1:
				mmi();		/*	Man-Machine Interface Board test	*/
				break;
			case 2:
				re_ts();	/*	Rotary Encoder/Touch Sensor Board Test	*/
				break;
			case 3:
				pwm();		/*	PWM Circuit Test			*/
				break;
			case 4:
				ps();		/*	Photo Sensor Circuit Test		*/
				break;
			case 5:
				sss();		/*	Supersonic Wave Sensor Circuit Test		*/
				break;
			case 6:
				pow();		/*	Power Distributor/Judgement Unit Test	*/
				break;
			case 0:
				endflg = ACTIVE;
				break;
			default:
				break;
		}
	}

	end();
}


/*	RS-232C controle function -------- initialize	*/
void	rs_init()
{
	outportb(CCR,RST_Tx);
	outportb(CCR,RST_TxCRC);
	outportb(CCR,RST_Rx);

	outportb(CMR1,0x17);	/*	asynchronous mode with even parity	*/
	outportb(CMR2,0x38);
	outportb(PCR,0x20);
	outportb(TPR,0x73);
	outportb(TTR,0x3d);	/*	bit rate 9600 bps	*/
	outportb(RPR,0x03);	/*	receiver parameter (character length 8 bit)	*/
	outportb(RTR,0x2d);
	outportb(OMR,0x10);	/*	TxRDY is active when TxFIFO is empty
					RxRDY is active when RxFIFO is not empty	*/
	asm(
	"	MOVEA.L		#$100,A0	* address = VCT * 4",
	"	MOVE.L		#_rs_get,(A0)"
	);
	outportb(IVR,VCT);
	outportb(IER,0x10);	/*	interrupts cause by RxRDY	*/
	outportb(ICR,0x02);	/*	vector is fixed	*/

	outportb(CCR,EBL_Tx);
	outportb(CCR,EBL_Rx);
}


/*	RS-232C controle function -------- receive	*/
void	rs_rcv( char *str_buf )
{
	char	*p = str_buf;
	char	*cur_get = getbuf;

	while ( (*cur_get != NULL) && (stpflg != ACTIVE) && (nextflg != ACTIVE) )
		*p++ = *cur_get++;
	*p = NULL;

	if ( stpflg != ACTIVE )
		end_get = getbuf;
}


/*	RS-232C controle function -------- send	*/
void	rs_snd( char *send_str )
{
	char	*cur_put = send_str;

	while( (*cur_put != NULL) && (stpflg != ACTIVE) && (nextflg != ACTIVE) )
	{
		if(*cur_put=='\n') *cur_put='\r';
		if ( ((inportb(GSR) & 0x02)>>1) == ACTIVE )
			outportb(TxFIFO,*cur_put++);
	}
}


/*	RS-232C controle function -------- key input interrupt	*/
interrupt void	rs_get()
{
	char	c;

	c = inportb(RxFIFO);

	switch ( c )
	{
		case '@':
			*end_get = NULL;
			stpflg = ACTIVE;
			break;
		case CR:
			*end_get = NULL;
			crflg = ACTIVE;
			break;
		case '?':
			*end_get = NULL;
			nextflg = ACTIVE;
			break;
		default:
			*end_get = c;
			break;
	}
	end_get++;
}


void	init()
{
	int 	no=NON ;

	rtc_clr();	/*	clear RTC		*/





		/*	stop wheels		*/
}


/*	clear Real Time Clock  registers	*/
void	rtc_clr()
{
	int	rtc_base;
	int	i;

	rtc_base=0xfdfe00;

	outportb(MSR,0x44);
	for ( i=3 ; rtc_base+ i<0xfdfe40 ; i+=2 ) outportb(rtc_base+i,0x00);

	outportb(MSR,0x04);
	for ( i=3 ; rtc_base+ i<0xfdfe0a ; i+=2 ) outportb(rtc_base+i,0x00);
}


/*	end function of TMP	*/
void	end()
{
	rs_snd("\n  --  END of TMP  --------------------------");
	rs_snd("\n  ////  O.K.  //// \n");

	endflg = !ACTIVE;

	while(1);
}
